<template>
  <div class="app-container">
    <el-card>
      <!--      <span style="margin-left: 15px">班次类型:</span>-->
      <el-select v-model="dataTypeValue" placeholder="电气元器件" clearable size="small" style="width:100px">
        <el-option
          v-for="item in dataType"
          :key="item.value"
          :label="item.label"
          :value="item.value"/>
      </el-select>
      <el-button type="primary" icon="el-icon-search" size="small" style="margin-left: 15px" plain @click="pageSize=20;pageCurrent=1;searchTable();searchTable1()">查询</el-button>
      <el-button type="distribution" icon="el-icon-circle-plus-outline" size="small" @click="addShiftTable('form')">新增</el-button>
      <el-button type="info" plain size="small" icon="el-icon-upload2" @click="importOrder('form')">导入</el-button>
      <el-table
        :data="tableData"
        border
        size="mini"
        height="750"
        center
        style="width: 100%">
        <el-table-column label="配方标志" align="center">
          <template slot-scope="scope">
            {{ scope.row.recipe_id }}
          </template>
        </el-table-column>
        <el-table-column label="名称" align="center">
          <template slot-scope="scope">
            {{ scope.row.MachineName }}
          </template>
        </el-table-column>
        <el-table-column label="编号" align="center">
          <template slot-scope="scope">
            {{ scope.row.MachineNum }}
          </template>
        </el-table-column>
        <el-table-column label="描述" align="center">
          <template slot-scope="scope">
            {{ scope.row.Described }}
          </template>
        </el-table-column>
        <el-table-column disabled label="状态" align="center">
          <template slot-scope="scope">
            {{ scope.row.Active }}
          </template>
        </el-table-column>
        <el-table-column label="备注" align="center">
          <template slot-scope="scope">
            {{ scope.row.Comments }}
          </template>
        </el-table-column>
        <el-table-column label="操作" width="200" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              plain
              icon="el-icon-edit"
              @click="editShiftTable(scope.row)">编辑</el-button>
            <el-button
              size="mini"
              type="text"
              plain
              icon="el-icon-delete"
              @click="handleDelete(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block" style="margin-top: 10px;">
        <el-pagination
          :current-page="pageCurrent"
          :page-sizes="[10, 20, 30, 40, 50]"
          :page-size="20"
          :total="total"
          layout="total, sizes, prev, pager, next, jumper"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"/>
      </div>
    </el-card>
    <el-dialog :visible.sync="dialogFormVisible" :title="title" center style="min-height: 200px;" width="400px">
      <el-form ref="form" :model="form" :rules="rules" label-position="right" label-width="110px">
        <el-form-item label="电气元器件" prop="dataTypeValue" style="display: inline-block">
          <el-select v-model="form.dataTypeValue" placeholder="电气元器件" clearable size="small" style="width:200px" @change="changeName(form.dataTypeValue)">
            <el-option
              v-for="item in dataType"
              :key="item.value"
              :label="item.label"
              :value="item.value"/>
          </el-select>
        </el-form-item>
        <el-form-item label="配方标志" prop="recipe_id" style="display: inline-block">
          <el-input v-model="form.recipe_id" clearable size="small" placeholder="配方标志" @change="checkData(form.recipe_id)"/>
        </el-form-item>
        <el-form-item label="编号" prop="value" style="display: inline-block">
          <el-input v-model="form.value" clearable size="small" placeholder="序号"/>
        </el-form-item>
        <el-form-item label="描述" prop="descript" style="display: inline-block">
          <el-input
            v-model="form.descript"
            clearable
            size="small"
            placeholder="描述"/>
        </el-form-item>
        <el-form-item label="是否禁用" prop="active" style="display: inline-block">
          <el-select v-model="form.active" placeholder="是否禁用" clearable size="small" style="width:200px">
            <el-option
              v-for="item in active"
              :key="item.value"
              :label="item.label"
              :value="item.value"/>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="comments" style="display: inline-block">
          <el-input
            v-model="form.comments"
            clearable
            size="small"
            placeholder="备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff('form')">取消</el-button>
        <el-button v-if="title === '增加'" type="primary" size="small" @click="submitAdd('form')">确定</el-button>
        <el-button v-if="title === '编辑'" type="primary" size="small" @click="submitAdd1('form')">确定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogFormVisible3" title="导入" center style="min-height: 200px" width="900px">
      <div class="app-container">
        <upload-excel-component style="margin-left: 15%" @on-selected-file="selected"/>
        <div style="margin-left: 395px">
          <span v-show="worksheet.length > 1" style="cursor: pointer;width: 50px;" @click="removeAll"><i class="el-icon-close"/></span>
          <el-upload :on-remove="handleRemove" :file-list="itemFile" style="width: 220px" action=""/>
        </div>
        <div v-if="worksheet.length !== 0" style="margin: 3px 0 0 395px">
          <el-button icon="el-icon-upload2" type="primary" size="small" @click="basicPartsToSQL">导入到数据库</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { sleep } from '../../../utils/tool'
import UploadExcelComponent from './UploadExcel.vue'
import request from '@/utils/request'
export default {
  name: 'UploadExcel',
  components: { UploadExcelComponent },
  data() {
    return {
      loading: true,
      worksheet: [],
      itemFile: [],
      unSpecification: [],
      dataTypeValue: '',
      dataType: [],
      tableData: [],
      tableData1: [],
      activeValue: '',
      active: [{
        label: '启用',
        value: 1
      }, {
        label: '禁用',
        value: 0
      }],
      dialogFormVisible: false,
      dialogFormVisible3: false,
      form: {
        name: '',
        value: '',
        descript: '',
        comments: '',
        ID: '',
        active: '',
        recipe_id: '',
        dataTypeValue: ''
      },
      rules: { // 表单验证规则
        dataTypeValue: [{ required: true, message: '请选择', trigger: 'change' }],
        name: [{ required: true, message: '请输入', trigger: 'blur' }]
      },
      title: '',
      pageCurrent: 1,
      pageSize: 20,
      total: 0
    }
  },
  created() {
    this.getNumber()
    this.searchTable()
    this.searchTable1()
  },
  methods: {
    getNumber() {
      this.dataType = []
      request({
        url: '',
        method: 'post',
        data: {
          type: '3',
          name: `SELECT [id],[name]  FROM [dbo].[Recipe_Work_Book] where [type]='电气元器件动作'`
        }
      }).then(response => {
        if (response.data.length) {
          for (let i = 0; i < response.data.length; i++) {
            this.dataType.push({
              label: response.data[i].name,
              value: response.data[i].id
            })
          }
        }
      })
    },
    changeName(val) {
      for (let i = 0; i < this.dataType.length; i++) {
        if (this.dataType[i].value === val) {
          console.log(this.dataType[i].label, 'this.stationNumber[i].label')
          this.form.name = this.dataType[i].label
        }
      }
    },
    searchTable() {
      this.tableData = []
      let dataTypeValue_check
      this.dataTypeValue ? dataTypeValue_check = 1 : dataTypeValue_check = 0
      var param = []
      param[0] = ['type_ischeck', dataTypeValue_check]
      param[1] = ['type', this.dataTypeValue]
      param[2] = ['PageCurrent', this.pageCurrent]
      param[3] = ['PageSize', this.pageSize]
      param[4] = ['PageCount', '1111', 'int', '1']
      param[5] = ['ItemCount', '1111', 'int', '1']
      var Data = this.CreateData('11', 'Recipe_Machine_Query', param)
      this.ExecDatabase(Data).then(response => {
        console.log(response, 66)
        if (response.data.result.length !== 0) {
          this.tableData = response.data.result
        }
        this.total = parseInt(response.data.output[0].ItemCount)
        this.loading = false
        console.log(this.tableData, 'this.tableData')
      })
    },
    searchTable1() {
      this.tableData1 = []
      var param = []
      var Data = this.CreateData('11', 'Recipe_Machine_Query_NEW', param)
      this.ExecDatabase(Data).then(response => {
        console.log(response, 66)
        if (response.data.length !== 0) {
          this.tableData1 = response.data
        }
        console.log(this.tableData1, 'this.tableData1')
      })
    },
    checkData(val) {
      for (let i = 0; i < this.tableData1.length; i++) {
        if (Number(this.tableData1[i].recipe_id) === Number(val)) {
          this.$message.error('数据已存在，请不要输入重复数据！')
          this.form.recipe_id = ''
        }
      }
    },
    addShiftTable(formName) {
      if (this.$refs[formName] !== undefined) {
        this.$refs[formName].resetFields()
      }
      this.title = '增加'
      this.form.name = ''
      this.form.value = ''
      this.form.descript = ''
      this.form.comments = ''
      this.form.dataTypeValue = ''
      this.form.active = ''
      this.form.recipe_id = ''
      this.dialogFormVisible = true
    },
    submitAdd(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['active', this.form.active]
          param[1] = ['type', this.form.dataTypeValue]
          param[2] = ['num', this.form.value]
          param[3] = ['descript', this.form.descript]
          param[4] = ['comments', this.form.comments]
          param[5] = ['recipe_id', this.form.recipe_id]
          var Data = this.CreateData('12', 'Recipe_Machine_Add', param)
          this.ExecDatabase(Data).then(response => {
            console.log(response)
            if (response.data[0].result === '1') {
              this.$message({
                message: '增加成功',
                type: 'success'
              })
              this.dialogFormVisible = false
              this.searchTable()
              this.searchTable1()
            } else {
              this.$message.error('增加失败！')
            }
          })
          this.dialogFormVisible = false
        } else {
          return false
        }
      })
    },
    editShiftTable(row) {
      if (this.$refs['form'] !== undefined) {
        this.$refs['form'].resetFields()
      }
      if (row.Active === '启用') {
        this.form.active = 1
      } else if (row.Active === '禁用') {
        this.form.active = 0
      } else {
        this.form.active = ''
      }
      this.form.value = row.MachineNum
      this.form.descript = row.Described
      this.form.comments = row.Comments
      this.form.ID = row.id
      this.form.dataTypeValue = row.MachineNo
      this.form.recipe_id = row.recipe_id
      this.title = '编辑'
      this.dialogFormVisible = true
    },
    submitAdd1() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['name', this.form.name]
          param[1] = ['type', this.form.dataTypeValue]
          param[2] = ['num', this.form.value]
          param[3] = ['descript', this.form.descript]
          param[4] = ['comments', this.form.comments]
          param[5] = ['id', this.form.ID]
          param[6] = ['active', this.form.active]
          param[7] = ['recipe_id', this.form.recipe_id]
          var Data = this.CreateData('12', 'Recipe_Machine_Update_NEW', param)
          this.ExecDatabase(Data).then(response => {
            if (response.data[0].result === '1') {
              this.$message({
                message: '修改成功',
                type: 'success'
              })
              this.searchTable()
              this.searchTable1()
            } else {
              this.$message.error('修改失败！')
            }
          })
          this.dialogFormVisible = false
        } else {
          return false
        }
      })
    },
    handleDelete(row) {
      this.$confirm('此操作将永久删除该数据, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        request({
          url: '',
          method: 'post',
          data: {
            type: '4',
            name: `delete from Recipe_Machine where id = ${row.id}`
          }
        }).then(response => {
          if (response.data[0].result === '1') {
            this.$message.success('删除成功')
            this.searchTable()
            this.searchTable1()
          } else {
            this.$message.error('删除失败')
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '取消删除'
        })
      })
    },
    callOff() {
      this.dialogFormVisible = false
    },
    importOrder() {
      this.dialogFormVisible3 = true
    },
    removeAll() {
      this.worksheet = []
      this.itemFile = []
    },
    async selected(data) { // 选择需要导入的文件
      console.log(data, 1111)
      this.worksheet = data.worksheet // 获取每个多选文件的表格坐标及值
      this.itemFile = data.itemFile
    },
    handleRemove(file) { // 移除文件
      for (let i = 0; i < this.itemFile.length; i++) {
        if (this.itemFile[i].name === file.name) {
          this.worksheet.splice(i, 1)
          this.itemFile.splice(i, 1)
        }
      }
    },
    async basicPartsToSQL() {
      try {
        this.loading = true
        this.err = 0
        for (let j = this.worksheet.length - 1; j >= 0; j--) {
          let name,
            value,
            descript,
            comments,
            recipe_id
          for (let i = 0; i < 999; i++) {
            const attr = i + 2
            name = this.worksheet[j][`A${attr}`] ? this.worksheet[j][`A${attr}`].v : ''
            value = this.worksheet[j][`B${attr}`] ? this.worksheet[j][`B${attr}`].v : ''
            descript = this.worksheet[j][`C${attr}`] ? this.worksheet[j][`C${attr}`].v : ''
            comments = this.worksheet[j][`D${attr}`] ? this.worksheet[j][`D${attr}`].v : ''
            recipe_id = this.worksheet[j][`E${attr}`] ? this.worksheet[j][`E${attr}`].v : ''
            console.log(name, value, descript, comments)
            if (!name) {
              break
            } else {
              if (name) {
                await sleep(50)
                await this.insertToSQL(name, value, descript, comments, recipe_id)
              } else {
                this.loading = false
                this.$notify.error(`请确认导入文件是否正确`)
                return
              }
            }
          }
          this.itemFile.splice(j, 1)
          this.worksheet.splice(j, 1)
          this.err === 0 ? this.$message.success(`导入完成`) : this.$message.error(`导入失败个数为${this.err}，请检查文件是否正确`)
        }
        this.loading = false
        this.searchTable()
        this.searchTable1()
      } catch (e) {
        this.err++
        this.loading = false
        this.$notify.error(`导入数据错误,请检查导入文件是否正确`)
        console.log(`导入数据错误${e}`)
      }
    },
    async insertToSQL(name, value, descript, comments, recipe_id) {
      try {
        var param = []
        param[0] = ['name', name]
        param[1] = ['num', value]
        param[2] = ['descript', descript]
        param[3] = ['comments', comments]
        param[4] = ['recipe_id', recipe_id]
        var Data = this.CreateData('12', 'Recipe_Machine_Excel', param)
        const response = await this.ExecDatabase(Data)
        if (response.data[0].result === '1') {
          this.$notify.success(`${name}导入成功`)
        } else {
          this.$notify.error(`${name}导入失败`)
        }
      } catch (e) {
        this.err++
        this.$message.error(`导入数据错误`)
        console.log(`导入数据错误${e}`)
      }
    },
    handleSizeChange(val) {
      this.pageSize = val
      this.pageCurrent = 1
      this.searchTable()
    },
    handleCurrentChange(val) {
      this.pageCurrent = val
      this.searchTable()
    }
  }
}
</script>

<style scoped>
</style>

